;Ukazetel stavu skore od 0-99 pro dva hrace.
;Rizeni vnitrnim oscilatorem. Dipley v multiplexnm provozu
;Rizeni preruseni od RMO 5ms. Pepinn displeju 200Hz.

	LIST P=16F630, R=DEC
	INCLUDE<P16F630.INC>
	__CONFIG 0x3FA4

W		EQU	0	;nastaveno pro umisteni vysledku
F		EQU	1	;operaci
OFFRAM	EQU	20h	;zacatek volne pameti procesoru

;--------promene------------------------			
W_SAVE	EQU	OFFRAM
STA_SAV	EQU	OFFRAM+1
FSR_SAV	EQU	OFFRAM+2
DISP1	EQU	OFFRAM+3	;pamet pro 1 segmentovku
DISP2	EQU	OFFRAM+4
DISP3	EQU	OFFRAM+5
DISP4	EQU	OFFRAM+6
CEK1	EQU	OFFRAM+7
CEK2	EQU	OFFRAM+8
CNTD	EQU	OFFRAM+9	;citac multiplexeru
PSW		EQU	OFFRAM+10	;registr priznaku
CNTSL	EQU	OFFRAM+11	;prechod do rezimu sleep
POM		EQU OFFRAM+12	;Pomocny pro rezim sleep

;--------definice----------------------
#DEFINE	TLAC1	PORTC,4	;hrac 1 
#DEFINE	TLAC2	PORTA,5	;hrac 2
#DEFINE	ZTL1	PSW,0	;stisk tlacitka 1
#DEFINE	ZTL2	PSW,1	;stisk tlacitka 2

	ORG	00h
	GOTO	START

	ORG	04h
	MOVWF	W_SAVE		;W zaloha
	SWAPF	STATUS,W	;status zaloha
	MOVWF	STA_SAV
	SWAPF	FSR,W
	MOVWF	FSR_SAV		;FSR zaloha
	GOTO	PRERUS

;------------TABULKY--------------------
TAB1					;Prekodovani znaku
	ADDWF	PCL,F		;Pricte W k citaci instrukci
	RETLW	B'00000000'	;Zobrazi 0
	RETLW	B'00000001'	;Zobrazi 1
	RETLW	B'00000010'	;Zobrazi 2
	RETLW	B'00000011'	;Zobrazi 3
	RETLW	B'00000100'	;Zobrazi 4
	RETLW	B'00000101'	;Zobrazi 5
	RETLW	B'00000110'	;Zobrazi 6
	RETLW	B'00000111'	;Zobrazi 7
	RETLW	B'00001000'	;Zobrazi 8
	RETLW	B'00001001'	;Zobrazi 9
	
TAB2					;Anoda display
	ADDWF	PCL,F
	RETLW	B'11111110'	;Anoda 1
	RETLW	B'11111101'	;Anoda 2
	RETLW	B'11111011'	;Anoda 3
	RETLW	B'11101111'	;Anoda 4
;---------------------------------------

;----------pomocne programy-------------
;----------cekani-----------------------
CEKEJ
	MOVLW	3
	MOVWF	CEK1
CEK	INCFSZ	CEK2,F
	GOTO	$-1
	DECFSZ	CEK1,F
	GOTO	CEK
	RETURN

;----------kontrola stavu tlacitka------
TLA1
	BTFSC	TLAC1	;Kontrola stavu tlacitka
	GOTO	TL1
	BCF		ZTL1	;neni stisknute
	RETURN
	
TL1
	BTFSC	ZTL1	;kontrola zda li nebyl jiz akceptovan
	RETURN
	BSF		ZTL1	;nastaveni priznaku tlacitka
	INCF	DISP1,F
	MOVF	DISP1,W
	SUBLW	10
	BTFSS	STATUS,Z	;jestli je vic nez 9
	GOTO	TL1END
	CLRF	DISP1
	INCF	DISP2,F
	MOVF	DISP2,W
	SUBLW	10
	BTFSC	STATUS,Z
	CLRF	DISP2
		
TL1END
	CLRF	CNTSL		;prechod do rezimu sleep
	RETURN


TLA2
	BTFSC	TLAC2	;Kontrola stavu tlacitka
	GOTO	TL2
	BCF		ZTL2	;neni stisknute
	RETURN
	
TL2
	BTFSC	ZTL2	;kontrola zda li nebyl jiz akceptovan
	RETURN
	BSF		ZTL2	;nastaveni priznaku tlacitka
	INCF	DISP3,F
	MOVF	DISP3,W
	SUBLW	10
	BTFSS	STATUS,Z	;jestli je vic nez 9
	GOTO	TL2END
	CLRF	DISP3
	INCF	DISP4,F
	MOVF	DISP4,W
	SUBLW	10
	BTFSC	STATUS,Z
	CLRF	DISP4
		
TL2END
	CLRF	CNTSL		;prechod do rezimu sleep
	RETURN

;*****************************************************
START	
	BCF		STATUS,RP0
	CLRF	PORTA
	MOVLW	07h			;Vypnuti komparatoru
	MOVWF	CMCON		;PortA I/O
	BSF		STATUS,RP0	;zakladni nastaveni
	MOVLW	B'11101000'
	MOVWF	TRISA
	MOVLW	B'11110000'
	MOVWF	TRISC
	MOVLW	B'11010100'	;Preddelicka 1:32 pred timer0
	MOVWF	OPTION_REG
	MOVLW	B'11100000'	;Povoleni preruseni pri zmene na portuA
	MOVWF	IOCA
	BCF		STATUS,RP0
	MOVLW	B'10100000'	;nastaveni moznosti preruseni
	MOVWF	INTCON
	MOVLW	100			;Zakladni hodnota timeru 
	MOVWF	TMR0		;pro dosazeni preruseni 5ms
	CLRF	CNTD
	CLRF	DISP1
	CLRF	DISP2
	CLRF	DISP3
	CLRF	DISP4
	CLRF	CEK2
	CLRF	PSW
	CLRF	CNTSL		;prechod do rezimu sleep
	
MAIN
	CALL	TLA1
	CALL	CEKEJ		;Chvili cekej 1,5ms
	CALL	TLA2
	CALL	CEKEJ		;Chvili cekej
	INCFSZ	POM,F
	GOTO	MAIN
	INCFSZ	CNTSL,F
	GOTO	MAIN
	GOTO	SPI			;Prechod do rezimu sleep

SPI						;cca po 5min
	CLRF	INTCON
	MOVLW	B'10001000'	;Preruseni od portuA
	MOVWF	INTCON
	MOVLW	B'11111111'	;Zhasni display
	MOVWF	PORTA
	SLEEP
	NOP
	GOTO	MAIN

PRERUS					;rizeni zobrazeni na displeji
	BTFSS	INTCON,2
	GOTO	PPORT		;Preruseno od portuA
	MOVLW	DISP1		;Neprima adresa
	MOVWF	FSR			;Neprime adresovani
	MOVF	CNTD,W		;Zvoli ktery display zobrazi
	ADDWF	FSR,F
	MOVF	INDF,W
	CALL	TAB1		;Zakodovani znaku
	MOVWF	PORTC		;Zaslani znaku na vystup
	MOVF	CNTD,W
	CALL	TAB2		;Vyber anody
	MOVWF	PORTA
	INCF	CNTD,F		;prictu 1 k cit. multiplexeru
	MOVF	CNTD,W
	SUBLW	4			;zkoumam ktery je to dipley
	BTFSC	STATUS,Z	;jestli druhy tak citac vynuluju 
	CLRF	CNTD
	GOTO	ENDPR

PPORT
	BTFSC	TLAC2	;Kontrola stavu tlacitka
	GOTO	$-1
	CLRF	CNTSL

ENDPR
	MOVLW	B'00100000'	;povoleni zpet pozadovanych preruseni
	MOVWF	INTCON
	MOVLW	100			;Zakladni hodnota timeru 
	MOVWF	TMR0		;pro dosazeni preruseni 5ms

	SWAPF	FSR_SAV,W
	MOVWF	FSR
	SWAPF	STA_SAV,W
	MOVWF	STATUS
	SWAPF	W_SAVE,F
	SWAPF	W_SAVE,W
	RETFIE

	END
